Subject: Re: [RFC 3/3] powerpc: Add DTS file for the Motorola PrPMC2800 platform

From: Segher Boessenkool <[email-masked]>
Date: Wed, 4 Apr 2007 19:44:15 +0200

> I'm not doing "device" init as in an I/O device.  I'm doing some bridge
> init (e.g, allowing pci devices to access system mem) plus getting VPD
> so I know what variant of the board I'm on.  With that info, I can
> determine the amount of memory, bus freq, etc.  Those properties
> should be correct in the dt before being passed to the kernel, IMHO.

Ah okay.  Yes if your firmware won't do this for you
this functionality belongs in the bootwrapper, agreed.

> Regarding "what you want to do is more complicated *anyway*",
> what I'm doing is in *addition* to however I get access to the regs.
> So adding page table groking code doesn't eliminate the need for what
> I'm doing.

Sure.  I'm just saying that adding memory map parsing code
wouldn't add much complexity to your case.  It will add some
code, sure ;-)

>> misusing the quick evil hack that was meant to get debug output
>> out originally isn't really warranted.
>
> While virtual-reg may be an evil hack, its also very a simple/small
> hack that saves us from adding a whole lot of code to the bootwrapper
> (i.e., either ioremap code or page table groking code).

I think you'll find it really isn't all that much code.

>> I said only _valid_ reason.
>
> And I respectfully disagree.  IMHO, my usage is entirely valid.
>
>> I know you're using it for more
>> things, that's what I'm complaining about :-)
>
> Understood (but disagreed :).

:-)

> Agreed and that's what I'm doing.  I'm configuring things that the fw
> really should have but didn't.

Yeah.

>>> For example, the VPD code
>>> in .../boot/prpmc2800.c in my patches.
>>
>> I cannot find those patches right now, but in general,
>> that kind of code belongs in the kernel (or in a run-time
>> firmware).
>
> See '***' BEGIN -> END above.

Right, you use the VPD to set up the device tree correctly.
That's perfectly fine :-)

Segher